module Wb8Uart16750 (
	clk_i,
	rst_i,
	baudce_i,
	wb_cyc_i,
	wb_stb_i,
	wb_we_i,
	wb_adr_i,
	wb_din_i,
	wb_dout_o,
	wb_ack_o,
	int_o,
	out1_o,
	out2_o,
	rclk_i,
	baudoutn_o,
	rtsn_o,
	dtrn_o,
	ctsn_i,
	dsrn_i,
	dcd_i,
	rin_i,
	sin_i,
	sout_o
);
	input wire clk_i;
	input wire rst_i;
	input wire baudce_i;
	input wire wb_cyc_i;
	input wire wb_stb_i;
	input wire wb_we_i;
	input wire [31:0] wb_adr_i;
	input wire [31:0] wb_din_i;
	output reg [31:0] wb_dout_o;
	output reg wb_ack_o;
	output wire int_o;
	output reg out1_o;
	output reg out2_o;
	input wire rclk_i;
	output reg baudoutn_o;
	output reg rtsn_o;
	output reg dtrn_o;
	input wire ctsn_i;
	input wire dsrn_i;
	input wire dcd_i;
	input wire rin_i;
	input wire sin_i;
	output reg sout_o;
	reg iWrite;
	reg iRead;
	reg [2:0] iA;
	reg [7:0] iDIN;
	reg iRBRRead;
	reg iTHRWrite;
	reg iDLLWrite;
	reg iDLMWrite;
	reg iIERWrite;
	reg iIIRRead;
	reg iFCRWrite;
	reg iLCRWrite;
	reg iMCRWrite;
	reg iLSRRead;
	reg iMSRRead;
	reg iSCRWrite;
	reg [7:0] iTSR;
	reg [7:0] iRBR;
	reg [7:0] iDLL;
	reg [7:0] iDLM;
	reg [7:0] iIER;
	reg [7:0] iIIR;
	reg [7:0] iFCR;
	reg [7:0] iLCR;
	reg [7:0] iMCR;
	reg [7:0] iLSR;
	reg [7:0] iMSR;
	reg [7:0] iSCR;
	reg iIER_ERBI;
	reg iIER_ETBEI;
	reg iIER_ELSI;
	reg iIER_EDSSI;
	reg iIIR_PI;
	reg iIIR_ID0;
	reg iIIR_ID1;
	reg iIIR_ID2;
	reg iIIR_FIFO64;
	reg iFCR_FIFOEnable;
	reg iFCR_RXFIFOReset;
	reg iFCR_TXFIFOReset;
	reg iFCR_DMAMode;
	reg iFCR_FIFO64E;
	reg [1:0] iFCR_RXTrigger;
	reg [1:0] iLCR_WLS;
	reg iLCR_STB;
	reg iLCR_PEN;
	reg iLCR_EPS;
	reg iLCR_SP;
	reg iLCR_BC;
	reg iLCR_DLAB;
	reg iMCR_DTR;
	reg iMCR_RTS;
	reg iMCR_OUT1;
	reg iMCR_OUT2;
	reg iMCR_LOOP;
	reg iMCR_AFE;
	reg iLSR_DR;
	reg iLSR_OE;
	reg iLSR_PE;
	reg iLSR_FE;
	reg iLSR_BI;
	reg iLSR_THRE;
	reg iLSR_TEMT;
	reg iLSR_FIFOERR;
	reg iMSR_dCTS;
	reg iMSR_dDSR;
	reg iMSR_TERI;
	reg iMSR_dDCD;
	reg iMSR_CTS;
	reg iMSR_DSR;
	reg iMSR_RI;
	reg iMSR_DCD;
	wire iCTSNs;
	wire iDSRNs;
	wire iDCDNs;
	wire iRINs;
	wire iCTSn;
	wire iDSRn;
	wire iDCDn;
	wire iRIn;
	wire iCTSnRE;
	wire iCTSnFE;
	wire iDSRnRE;
	wire iDSRnFE;
	wire iDCDnRE;
	wire iDCDnFE;
	wire iRInRE;
	wire iRInFE;
	reg [15:0] iBaudgenDiv;
	wire iBaudtick16x;
	wire iBaudtick2x;
	wire iRCLK;
	reg iTXFIFOClear;
	reg iTXFIFOWrite;
	reg iTXFIFORead;
	wire iTXFIFOEmpty;
	reg iTXFIFOFull;
	reg iTXFIFO16Full;
	wire iTXFIFO64Full;
	wire [5:0] iTXFIFOUsage;
	wire [7:0] iTXFIFOQ;
	reg iRXFIFOClear;
	reg iRXFIFOWrite;
	reg iRXFIFORead;
	wire iRXFIFOEmpty;
	reg iRXFIFOFull;
	reg iRXFIFO16Full;
	wire iRXFIFO64Full;
	reg [10:0] iRXFIFOD;
	wire [10:0] iRXFIFOQ;
	wire [5:0] iRXFIFOUsage;
	reg iRXFIFOTrigger;
	reg iRXFIFO16Trigger;
	reg iRXFIFO64Trigger;
	reg iRXFIFOPE;
	reg iRXFIFOFE;
	reg iRXFIFOBI;
	wire iSOUT;
	reg iTXStart;
	reg iTXClear;
	wire iTXFinished;
	reg iTXRunning;
	wire iSINr;
	reg iSIN;
	wire iRXFinished;
	reg iRXClear;
	wire [7:0] iRXData;
	wire iRXPE;
	wire iRXFE;
	wire iRXBI;
	wire iFERE;
	wire iPERE;
	wire iBIRE;
	reg [6:0] iFECounter;
	reg iFEIncrement;
	reg iFEDecrement;
	reg iRDAInterrupt;
	reg [5:0] iTimeoutCount;
	reg iCharTimeout;
	wire iLSR_THRERE;
	reg iTHRInterrupt;
	reg iTXEnable;
	reg iRTS;
	reg WB_ACK_R;
	wire clock_enable;
	reg [3:0] iIER_3_0;
	reg [4:0] iLSR_4_0;
	reg [3:0] iMSR_3_0;
	wire [3:0] iIIR_3_0;
	reg [3:0] iIIR_7_4;
	wire NC_fe_o;
	wire NC_fe_o_2;
	wire NC_fe_o_3;
	wire NC_fe_o_4;
	wire NC_fe_o_5;
	wire NC_i;
	reg rx_state;
	reg next_rx_state;
	reg [1:0] tx_state;
	reg [1:0] next_tx_state;
	reg [10:0] next_iRXFIFOD;
	reg [31:0] iTSR_next;
	always @(*) begin : TransitionMethod
		reg [2:0] iA_var;
		reg [2:0] wb_adr_var;
		reg [7:0] iIER_var;
		reg [7:0] iIIR_var;
		reg [7:0] iLCR_var;
		reg [7:0] iMCR_var;
		reg [10:0] iRXFIFOD_var;
		reg [10:0] iRXFIFOQ_var;
		reg [7:0] iFCR_var;
		reg [7:0] iLSR_var;
		reg [7:0] iMSR_var;
		reg [5:0] iTXFIFOUsage_var;
		reg [5:0] iRXFIFOUsage_var;
		reg [31:0] wb_din_i_var;
		reg [15:0] iBaudgenDiv_var;
		reg isAddressed;
		iA_var = iA;
		wb_adr_var = wb_adr_i / 4;
		iIER_var = iIER;
		iIIR_var = iIIR;
		iLCR_var = iLCR;
		iMCR_var = iMCR;
		iRXFIFOD_var = iRXFIFOD;
		iRXFIFOQ_var = iRXFIFOQ;
		iFCR_var = iFCR;
		iLSR_var = iLSR;
		iMSR_var = iMSR;
		iTXFIFOUsage_var = iTXFIFOUsage;
		iRXFIFOUsage_var = iRXFIFOUsage;
		wb_din_i_var = wb_din_i;
		iBaudgenDiv_var = iBaudgenDiv;
		isAddressed = |('h60000000 & wb_adr_i) && (wb_adr_i <= 1610612764);
		if (((((wb_cyc_i == 1) && (wb_stb_i == 1)) && (wb_we_i == 1)) && (WB_ACK_R == 1)) && isAddressed)
			iWrite = 1;
		else
			iWrite = 0;
		if (((((wb_cyc_i == 1) && (wb_stb_i == 1)) && (wb_we_i == 0)) && (WB_ACK_R == 1)) && isAddressed)
			iRead = 1;
		else
			iRead = 0;
		if (((iRead == 1) && (iA == 0)) && (iLCR_DLAB == 0))
			iRBRRead = 1;
		else
			iRBRRead = 0;
		if (((iWrite == 1) && (iA == 0)) && (iLCR_DLAB == 0))
			iTHRWrite = 1;
		else
			iTHRWrite = 0;
		if (((iWrite == 1) && (iA == 0)) && (iLCR_DLAB == 1))
			iDLLWrite = 1;
		else
			iDLLWrite = 0;
		if (((iWrite == 1) && (iA == 1)) && (iLCR_DLAB == 1))
			iDLMWrite = 1;
		else
			iDLMWrite = 0;
		if (((iWrite == 1) && (iA == 1)) && (iLCR_DLAB == 0))
			iIERWrite = 1;
		else
			iIERWrite = 0;
		if ((iRead == 1) && (iA == 2))
			iIIRRead = 1;
		else
			iIIRRead = 0;
		if ((iWrite == 1) && (iA == 2))
			iFCRWrite = 1;
		else
			iFCRWrite = 0;
		if ((iWrite == 1) && (iA == 3))
			iLCRWrite = 1;
		else
			iLCRWrite = 0;
		if ((iWrite == 1) && (iA == 4))
			iMCRWrite = 1;
		else
			iMCRWrite = 0;
		if ((iRead == 1) && (iA == 5))
			iLSRRead = 1;
		else
			iLSRRead = 0;
		if ((iRead == 1) && (iA == 6))
			iMSRRead = 1;
		else
			iMSRRead = 0;
		if ((iWrite == 1) && (iA == 7))
			iSCRWrite = 1;
		else
			iSCRWrite = 0;
		iA = wb_adr_var[2:0];
		iDIN = wb_din_i_var[7:0];
		wb_ack_o = WB_ACK_R;
		iIER_ERBI = iIER_var[0];
		iIER_ETBEI = iIER_var[1];
		iIER_ELSI = iIER_var[2];
		iIER_EDSSI = iIER_var[3];
		if (((iFCR_FIFOEnable == 0) && (iLSR_DR == 1)) || ((iFCR_FIFOEnable == 1) && (iRXFIFOTrigger == 1)))
			iRDAInterrupt = 1;
		else
			iRDAInterrupt = 0;
		iIIR_PI = iIIR_var[0];
		iIIR_ID0 = iIIR_var[1];
		iIIR_ID1 = iIIR_var[2];
		iIIR_ID2 = iIIR_var[3];
		iIIR_FIFO64 = iIIR_var[5];
		iIIR_var[4] = 0;
		if (iFCR_FIFOEnable == 1)
			iIIR_var[5] = iFCR_FIFO64E;
		else
			iIIR_var[5] = 0;
		iIIR_var[6] = iFCR_FIFOEnable;
		iIIR_var[7] = iFCR_FIFOEnable;
		iFCR_var[0] = iFCR_FIFOEnable;
		iFCR_var[1] = iFCR_RXFIFOReset;
		iFCR_var[2] = iFCR_TXFIFOReset;
		iFCR_var[3] = iFCR_DMAMode;
		iFCR_var[4] = 0;
		iFCR_var[5] = iFCR_FIFO64E;
		iFCR_var[7:6] = iFCR_RXTrigger;
		iLCR_WLS = iLCR_var[1:0];
		iLCR_STB = iLCR_var[2];
		iLCR_PEN = iLCR_var[3];
		iLCR_EPS = iLCR_var[4];
		iLCR_SP = iLCR_var[5];
		iLCR_BC = iLCR_var[6];
		iLCR_DLAB = iLCR_var[7];
		iMCR_DTR = iMCR_var[0];
		iMCR_RTS = iMCR_var[1];
		iMCR_OUT1 = iMCR_var[2];
		iMCR_OUT2 = iMCR_var[3];
		iMCR_LOOP = iMCR_var[4];
		iMCR_AFE = iMCR_var[5];
		iMCR_var[7:6] = 0;
		iRXFIFOPE = ((iRXFIFOEmpty == 0) && (iRXFIFOQ_var[8] == 1) ? 1 : 0);
		iRXFIFOFE = ((iRXFIFOEmpty == 0) && (iRXFIFOQ_var[9] == 1) ? 1 : 0);
		iRXFIFOBI = ((iRXFIFOEmpty == 0) && (iRXFIFOQ_var[10] == 1) ? 1 : 0);
		iFEIncrement = ((iRXFIFOWrite == 1) && (iRXFIFOD_var[10:8] != 0) ? 1 : 0);
		iFEDecrement = (((iFECounter != 0) && (iRXFIFOEmpty == 0)) && (((iPERE == 1) || (iFERE == 1)) || (iBIRE == 1)) ? 1 : 0);
		iLSR_var[0] = iLSR_DR;
		iLSR_var[1] = iLSR_OE;
		iLSR_var[2] = iLSR_PE;
		iLSR_var[3] = iLSR_FE;
		iLSR_var[4] = iLSR_BI;
		iLSR_var[5] = iLSR_THRE;
		iLSR_var[6] = iLSR_TEMT;
		iLSR_var[7] = ((iFCR_FIFOEnable == 1) && (iLSR_FIFOERR == 1) ? 1 : 0);
		iLSR_DR = ((iRXFIFOEmpty == 0) || (iRXFIFOWrite == 1) ? 1 : 0);
		iLSR_THRE = (iTXFIFOEmpty == 1 ? 1 : 0);
		iLSR_TEMT = ((iTXRunning == 0) && (iLSR_THRE == 1) ? 1 : 0);
		iMSR_CTS = (((iMCR_LOOP == 1) && (iRTS == 1)) || ((iMCR_LOOP == 0) && (iCTSn == 0)) ? 1 : 0);
		iMSR_DSR = (((iMCR_LOOP == 1) && (iMCR_DTR == 1)) || ((iMCR_LOOP == 0) && (iDSRn == 0)) ? 1 : 0);
		iMSR_RI = (((iMCR_LOOP == 1) && (iMCR_OUT1 == 1)) || ((iMCR_LOOP == 0) && (iRIn == 0)) ? 1 : 0);
		iMSR_DCD = (((iMCR_LOOP == 1) && (iMCR_OUT2 == 1)) || ((iMCR_LOOP == 0) && (iDCDn == 0)) ? 1 : 0);
		iMSR_var[0] = iMSR_dCTS;
		iMSR_var[1] = iMSR_dDSR;
		iMSR_var[2] = iMSR_TERI;
		iMSR_var[3] = iMSR_dDCD;
		iMSR_var[4] = iMSR_CTS;
		iMSR_var[5] = iMSR_DSR;
		iMSR_var[6] = iMSR_RI;
		iMSR_var[7] = iMSR_DCD;
		iTXFIFO16Full = iTXFIFOUsage_var[4];
		iTXFIFOFull = (iFCR_FIFO64E == 0 ? iTXFIFO16Full : iTXFIFO64Full);
		if ((((iFCR_FIFOEnable == 0) && (iTXFIFOEmpty == 1)) || ((iFCR_FIFOEnable == 1) && (iTXFIFOFull == 0))) && (iTHRWrite == 1))
			iTXFIFOWrite = 1;
		else
			iTXFIFOWrite = 0;
		iTXFIFOClear = (iFCR_TXFIFOReset == 1 ? 1 : 0);
		iRXFIFORead = (iRBRRead == 1 ? 1 : 0);
		iRXFIFO16Full = iRXFIFOUsage_var[4];
		iRXFIFOFull = (iFCR_FIFO64E == 0 ? iRXFIFO16Full : iRXFIFO64Full);
		iRBR = iRXFIFOQ_var[7:0];
		if ((((((iFCR_RXTrigger == 0) && (iRXFIFOEmpty == 0)) || ((iFCR_RXTrigger == 1) && ((iRXFIFOUsage_var[2] == 1) || (iRXFIFOUsage_var[3] == 1)))) || ((iFCR_RXTrigger == 2) && (iRXFIFOUsage_var[3] == 1))) || ((((iFCR_RXTrigger == 3) && (iRXFIFOUsage_var[3] == 1)) && (iRXFIFOUsage_var[2] == 1)) && (iRXFIFOUsage_var[1] == 1))) || (iRXFIFO16Full == 1))
			iRXFIFO16Trigger = 1;
		else
			iRXFIFO16Trigger = 0;
		if ((((((iFCR_RXTrigger == 0) && (iRXFIFOEmpty == 0)) || ((iFCR_RXTrigger == 1) && ((iRXFIFOUsage_var[4] == 1) || (iRXFIFOUsage_var[5] == 1)))) || ((iFCR_RXTrigger == 2) && (iRXFIFOUsage_var[5] == 1))) || ((((iFCR_RXTrigger == 3) && (iRXFIFOUsage_var[5] == 1)) && (iRXFIFOUsage_var[4] == 1)) && (iRXFIFOUsage_var[3] == 1))) || (iRXFIFO64Full == 1))
			iRXFIFO64Trigger = 1;
		else
			iRXFIFO64Trigger = 0;
		iRXFIFOTrigger = (iFCR_FIFO64E == 0 ? iRXFIFO16Trigger : iRXFIFO64Trigger);
		iRXClear = 0;
		iTXClear = 0;
		iSIN = (iMCR_LOOP == 0 ? iSINr : iSOUT);
		if ((iTXFIFOEmpty == 0) && ((iMCR_AFE == 0) || ((iMCR_AFE == 1) && (iMSR_CTS == 1))))
			iTXEnable = 1;
		else
			iTXEnable = 0;
		iBaudgenDiv_var[15:8] = iDLM;
		iBaudgenDiv_var[7:0] = iDLL;
		iBaudgenDiv = iBaudgenDiv_var;
		iIIR_7_4 = iIIR_var[7:4];
		iFCR = iFCR_var;
		iLSR = iLSR_var;
		iMSR = iMSR_var;
	end
	always @(*) begin : WriteMethod
		reg [7:0] iLSR_var;
		reg [7:0] iMSR_var;
		iLSR_var = iLSR;
		iMSR_var = iMSR;
		iLSR_4_0 = iLSR_var[4:0];
		iMSR_3_0 = iMSR_var[3:0];
	end
	reg WB_ACK_R_next;
	task WBAckPrMethod_func;
		begin
			WB_ACK_R_next = WB_ACK_R;
			if (WB_ACK_R == 1)
				WB_ACK_R_next = 0;
			else if ((wb_cyc_i == 1) && (wb_stb_i == 1))
				WB_ACK_R_next = 1;
		end
	endtask
	always @(Wb8Uart16750.wb_stb_i or Wb8Uart16750.wb_cyc_i or Wb8Uart16750.WB_ACK_R or Wb8Uart16750.WB_ACK_R) begin : WBAckPrMethod_comb
		WBAckPrMethod_func;
	end
	always @(posedge clk_i) begin : WBAckPrMethod_ff
		if (rst_i)
			WB_ACK_R <= 1;
		else
			WB_ACK_R <= WB_ACK_R_next;
	end
	reg [7:0] iDLL_next;
	reg [7:0] iDLM_next;
	task UartDlrMethod_func;
		begin
			iDLL_next = iDLL;
			iDLM_next = iDLM;
			if (iDLLWrite == 1)
				iDLL_next = iDIN;
			if (iDLMWrite == 1)
				iDLM_next = iDIN;
		end
	endtask
	always @(Wb8Uart16750.iDIN or Wb8Uart16750.iDLMWrite or Wb8Uart16750.iDIN or Wb8Uart16750.iDLLWrite or Wb8Uart16750.iDLM or Wb8Uart16750.iDLL) begin : UartDlrMethod_comb
		UartDlrMethod_func;
	end
	always @(posedge clk_i) begin : UartDlrMethod_ff
		if (rst_i) begin
			iDLL <= 0;
			iDLM <= 0;
		end
		else begin
			iDLL <= iDLL_next;
			iDLM <= iDLM_next;
		end
	end
	reg [3:0] iIER_3_0_next;
	task UartIerMethod_func;
		reg [7:0] iDIN_var;
		begin
			iIER_3_0_next = iIER_3_0;
			iDIN_var = iDIN;
			if (iIERWrite == 1)
				iIER_3_0_next = iDIN_var[3:0];
		end
	endtask
	always @(Wb8Uart16750.iIERWrite or Wb8Uart16750.iDIN or Wb8Uart16750.iIER_3_0) begin : UartIerMethod_comb
		UartIerMethod_func;
	end
	always @(posedge clk_i) begin : UartIerMethod_ff
		if (rst_i) begin : sv2v_autoblock_1
			reg [7:0] iDIN_var;
			iDIN_var = 0;
			iIER_3_0 <= 0;
		end
		else
			iIER_3_0 <= iIER_3_0_next;
	end
	reg iTHRInterrupt_next;
	task UartIicThreiMethod_func;
		reg [7:0] iDIN_var;
		reg [7:0] iIIR_var;
		begin
			iTHRInterrupt_next = iTHRInterrupt;
			iDIN_var = iDIN;
			iIIR_var = iIIR;
			if (((iLSR_THRERE == 1) || (iFCR_TXFIFOReset == 1)) || (((iIERWrite == 1) && (iDIN_var[1] == 1)) && (iLSR_THRE == 1)))
				iTHRInterrupt_next = 1;
			else if (((iIIRRead == 1) && (iIIR_var[3:1] == 1)) || (iTHRWrite == 1))
				iTHRInterrupt_next = 0;
		end
	endtask
	always @(Wb8Uart16750.iTHRWrite or Wb8Uart16750.iIIRRead or Wb8Uart16750.iLSR_THRE or Wb8Uart16750.iIERWrite or Wb8Uart16750.iFCR_TXFIFOReset or Wb8Uart16750.iLSR_THRERE or Wb8Uart16750.iIIR or Wb8Uart16750.iDIN or Wb8Uart16750.iTHRInterrupt) begin : UartIicThreiMethod_comb
		UartIicThreiMethod_func;
	end
	always @(posedge clk_i) begin : UartIicThreiMethod_ff
		if (rst_i) begin : sv2v_autoblock_2
			reg [7:0] iDIN_var;
			reg [7:0] iIIR_var;
			iDIN_var = 0;
			iIIR_var = 0;
			iTHRInterrupt <= 0;
		end
		else
			iTHRInterrupt <= iTHRInterrupt_next;
	end
	reg [5:0] iTimeoutCount_next;
	reg iCharTimeout_next;
	task UartCtiMethod_func;
		reg [7:0] iTimeoutCount_var;
		begin
			iCharTimeout_next = iCharTimeout;
			iTimeoutCount_next = iTimeoutCount;
			iTimeoutCount_var = iTimeoutCount;
			if (((iRXFIFOEmpty == 1) || (iRBRRead == 1)) || (iRXFIFOWrite == 1))
				iTimeoutCount_next = 0;
			else if (((iRXFIFOEmpty == 0) && (iBaudtick2x == 1)) && (iTimeoutCount_var[5] == 0))
				iTimeoutCount_next = iTimeoutCount + 1;
			if (iFCR_FIFOEnable == 1) begin
				if (iRBRRead == 1)
					iCharTimeout_next = 0;
				else if (iTimeoutCount_var[5] == 1)
					iCharTimeout_next = 1;
			end
			else
				iCharTimeout_next = 0;
		end
	endtask
	always @(Wb8Uart16750.iRBRRead or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iTimeoutCount or Wb8Uart16750.iBaudtick2x or Wb8Uart16750.iRXFIFOEmpty or Wb8Uart16750.iRXFIFOWrite or Wb8Uart16750.iRBRRead or Wb8Uart16750.iRXFIFOEmpty or Wb8Uart16750.iTimeoutCount or Wb8Uart16750.iTimeoutCount or Wb8Uart16750.iCharTimeout) begin : UartCtiMethod_comb
		UartCtiMethod_func;
	end
	always @(posedge clk_i) begin : UartCtiMethod_ff
		if (rst_i) begin : sv2v_autoblock_3
			reg [7:0] iTimeoutCount_var;
			iTimeoutCount_var = 0;
			iTimeoutCount <= 0;
			iCharTimeout <= 0;
		end
		else begin
			iTimeoutCount <= iTimeoutCount_next;
			iCharTimeout <= iCharTimeout_next;
		end
	end
	reg iFCR_FIFOEnable_next;
	reg iFCR_RXFIFOReset_next;
	reg iFCR_TXFIFOReset_next;
	reg iFCR_DMAMode_next;
	reg iFCR_FIFO64E_next;
	reg [1:0] iFCR_RXTrigger_next;
	task UartFcrMethod_func;
		reg [7:0] iDIN_var;
		begin
			iFCR_DMAMode_next = iFCR_DMAMode;
			iFCR_FIFO64E_next = iFCR_FIFO64E;
			iFCR_FIFOEnable_next = iFCR_FIFOEnable;
			iFCR_RXFIFOReset_next = iFCR_RXFIFOReset;
			iFCR_RXTrigger_next = iFCR_RXTrigger;
			iFCR_TXFIFOReset_next = iFCR_TXFIFOReset;
			iFCR_RXFIFOReset_next = 0;
			iFCR_TXFIFOReset_next = 0;
			iDIN_var = iDIN;
			if (iFCRWrite == 1) begin
				iFCR_FIFOEnable_next = iDIN_var[0];
				iFCR_DMAMode_next = iDIN_var[3];
				iFCR_RXTrigger_next = iDIN_var[7:6];
				if (iLCR_DLAB == 1)
					iFCR_FIFO64E_next = iDIN_var[5];
				if (((iDIN_var[1] == 1) || ((iFCR_FIFOEnable == 0) && (iDIN_var[0] == 1))) || ((iFCR_FIFOEnable == 1) && (iDIN_var[0] == 0)))
					iFCR_RXFIFOReset_next = 1;
				if (((iDIN_var[2] == 1) || ((iFCR_FIFOEnable == 0) && (iDIN_var[0] == 1))) || ((iFCR_FIFOEnable == 1) && (iDIN_var[0] == 0)))
					iFCR_TXFIFOReset_next = 1;
			end
		end
	endtask
	always @(Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iLCR_DLAB or Wb8Uart16750.iFCRWrite or Wb8Uart16750.iDIN or Wb8Uart16750.iFCR_TXFIFOReset or Wb8Uart16750.iFCR_RXTrigger or Wb8Uart16750.iFCR_RXFIFOReset or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iFCR_FIFO64E or Wb8Uart16750.iFCR_DMAMode) begin : UartFcrMethod_comb
		UartFcrMethod_func;
	end
	always @(posedge clk_i) begin : UartFcrMethod_ff
		if (rst_i) begin : sv2v_autoblock_4
			reg [7:0] iDIN_var;
			iDIN_var = 0;
			iFCR_FIFOEnable <= 0;
			iFCR_RXFIFOReset <= 0;
			iFCR_TXFIFOReset <= 0;
			iFCR_DMAMode <= 0;
			iFCR_FIFO64E <= 0;
			iFCR_RXTrigger <= 0;
		end
		else begin
			iFCR_FIFOEnable <= iFCR_FIFOEnable_next;
			iFCR_RXFIFOReset <= iFCR_RXFIFOReset_next;
			iFCR_TXFIFOReset <= iFCR_TXFIFOReset_next;
			iFCR_DMAMode <= iFCR_DMAMode_next;
			iFCR_FIFO64E <= iFCR_FIFO64E_next;
			iFCR_RXTrigger <= iFCR_RXTrigger_next;
		end
	end
	reg [7:0] iLCR_next;
	task UartLcrMethod_func;
		begin
			iLCR_next = iLCR;
			if (iLCRWrite == 1)
				iLCR_next = iDIN;
		end
	endtask
	always @(Wb8Uart16750.iDIN or Wb8Uart16750.iLCRWrite or Wb8Uart16750.iLCR) begin : UartLcrMethod_comb
		UartLcrMethod_func;
	end
	always @(posedge clk_i) begin : UartLcrMethod_ff
		if (rst_i)
			iLCR <= 0;
		else
			iLCR <= iLCR_next;
	end
	reg [7:0] iMCR_next;
	task UartMcrMethod_func;
		reg [7:0] iMCR_var;
		reg [7:0] iDIN_var;
		begin
			iMCR_next = iMCR;
			iMCR_var = iMCR;
			iDIN_var = iDIN;
			if (iMCRWrite == 1) begin
				iMCR_var[5:0] = iDIN_var[5:0];
				iMCR_next = iMCR_var;
			end
		end
	endtask
	always @(Wb8Uart16750.iMCRWrite or Wb8Uart16750.iDIN or Wb8Uart16750.iMCR or Wb8Uart16750.iMCR) begin : UartMcrMethod_comb
		UartMcrMethod_func;
	end
	always @(posedge clk_i) begin : UartMcrMethod_ff
		if (rst_i) begin : sv2v_autoblock_5
			reg [7:0] iMCR_var;
			reg [7:0] iDIN_var;
			iMCR_var = 0;
			iDIN_var = 0;
			iMCR <= 0;
		end
		else
			iMCR <= iMCR_next;
	end
	reg iLSR_OE_next;
	reg iLSR_PE_next;
	reg iLSR_FE_next;
	reg iLSR_BI_next;
	reg [6:0] iFECounter_next;
	reg iLSR_FIFOERR_next;
	task UartLsrMethod_func;
		reg [10:0] iRXFIFOQ_var;
		begin
			iFECounter_next = iFECounter;
			iLSR_BI_next = iLSR_BI;
			iLSR_FE_next = iLSR_FE;
			iLSR_FIFOERR_next = iLSR_FIFOERR;
			iLSR_OE_next = iLSR_OE;
			iLSR_PE_next = iLSR_PE;
			iRXFIFOQ_var = iRXFIFOQ;
			if ((((iFCR_FIFOEnable == 0) && (iLSR_DR == 1)) && (iRXFinished == 1)) || (((iFCR_FIFOEnable == 1) && (iRXFIFOFull == 1)) && (iRXFinished == 1)))
				iLSR_OE_next = 1;
			else if (iLSRRead == 1)
				iLSR_OE_next = 0;
			if (iPERE == 1)
				iLSR_PE_next = 1;
			else if (iLSRRead == 1)
				iLSR_PE_next = 0;
			if (iFERE == 1)
				iLSR_FE_next = 1;
			else if (iLSRRead == 1)
				iLSR_FE_next = 0;
			if (iBIRE == 1)
				iLSR_BI_next = 1;
			else if (iLSRRead == 1)
				iLSR_BI_next = 0;
			if (iFECounter != 0)
				iLSR_FIFOERR_next = 1;
			else if ((iRXFIFOEmpty == 1) || (iRXFIFOQ_var[10:8] == 0))
				iLSR_FIFOERR_next = 0;
			if (iRXFIFOClear == 1)
				iFECounter_next = 0;
			else if ((iFEIncrement == 1) && (iFEDecrement == 0))
				iFECounter_next = iFECounter + 1;
			else if ((iFEIncrement == 0) && (iFEDecrement == 1))
				iFECounter_next = iFECounter - 1;
		end
	endtask
	always @(Wb8Uart16750.iFECounter or Wb8Uart16750.iFEDecrement or Wb8Uart16750.iFEIncrement or Wb8Uart16750.iFECounter or Wb8Uart16750.iFEDecrement or Wb8Uart16750.iFEIncrement or Wb8Uart16750.iRXFIFOClear or Wb8Uart16750.iRXFIFOEmpty or Wb8Uart16750.iFECounter or Wb8Uart16750.iLSRRead or Wb8Uart16750.iBIRE or Wb8Uart16750.iLSRRead or Wb8Uart16750.iFERE or Wb8Uart16750.iLSRRead or Wb8Uart16750.iPERE or Wb8Uart16750.iLSRRead or Wb8Uart16750.iRXFinished or Wb8Uart16750.iRXFIFOFull or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iRXFinished or Wb8Uart16750.iLSR_DR or Wb8Uart16750.iFCR_FIFOEnable or Wb8Uart16750.iRXFIFOQ or Wb8Uart16750.iLSR_PE or Wb8Uart16750.iLSR_OE or Wb8Uart16750.iLSR_FIFOERR or Wb8Uart16750.iLSR_FE or Wb8Uart16750.iLSR_BI or Wb8Uart16750.iFECounter) begin : UartLsrMethod_comb
		UartLsrMethod_func;
	end
	always @(posedge clk_i) begin : UartLsrMethod_ff
		if (rst_i) begin : sv2v_autoblock_6
			reg [10:0] iRXFIFOQ_var;
			iRXFIFOQ_var = 0;
			iLSR_OE <= 0;
			iLSR_PE <= 0;
			iLSR_FE <= 0;
			iLSR_BI <= 0;
			iFECounter <= 0;
		end
		else begin
			iLSR_OE <= iLSR_OE_next;
			iLSR_PE <= iLSR_PE_next;
			iLSR_FE <= iLSR_FE_next;
			iLSR_BI <= iLSR_BI_next;
			iFECounter <= iFECounter_next;
			iLSR_FIFOERR <= iLSR_FIFOERR_next;
		end
	end
	reg iMSR_dCTS_next;
	reg iMSR_dDSR_next;
	reg iMSR_TERI_next;
	reg iMSR_dDCD_next;
	task UartMsrMethod_func;
		begin
			iMSR_TERI_next = iMSR_TERI;
			iMSR_dCTS_next = iMSR_dCTS;
			iMSR_dDCD_next = iMSR_dDCD;
			iMSR_dDSR_next = iMSR_dDSR;
			if ((iCTSnRE == 1) || (iCTSnFE == 1))
				iMSR_dCTS_next = 1;
			else if (iMSRRead == 1)
				iMSR_dCTS_next = 0;
			if ((iDSRnRE == 1) || (iDSRnFE == 1))
				iMSR_dDSR_next = 1;
			else if (iMSRRead == 1)
				iMSR_dDSR_next = 0;
			if (iRInFE == 1)
				iMSR_TERI_next = 1;
			else if (iMSRRead == 1)
				iMSR_TERI_next = 0;
			if ((iDCDnRE == 1) || (iDCDnFE == 1))
				iMSR_dDCD_next = 1;
			else if (iMSRRead == 1)
				iMSR_dDCD_next = 0;
		end
	endtask
	always @(Wb8Uart16750.iMSRRead or Wb8Uart16750.iDCDnFE or Wb8Uart16750.iDCDnRE or Wb8Uart16750.iMSRRead or Wb8Uart16750.iRInFE or Wb8Uart16750.iMSRRead or Wb8Uart16750.iDSRnFE or Wb8Uart16750.iDSRnRE or Wb8Uart16750.iMSRRead or Wb8Uart16750.iCTSnFE or Wb8Uart16750.iCTSnRE or Wb8Uart16750.iMSR_dDSR or Wb8Uart16750.iMSR_dDCD or Wb8Uart16750.iMSR_dCTS or Wb8Uart16750.iMSR_TERI) begin : UartMsrMethod_comb
		UartMsrMethod_func;
	end
	always @(posedge clk_i) begin : UartMsrMethod_ff
		if (rst_i) begin
			iMSR_dCTS <= 0;
			iMSR_dDSR <= 0;
			iMSR_TERI <= 0;
			iMSR_dDCD <= 0;
		end
		else begin
			iMSR_dCTS <= iMSR_dCTS_next;
			iMSR_dDSR <= iMSR_dDSR_next;
			iMSR_TERI <= iMSR_TERI_next;
			iMSR_dDCD <= iMSR_dDCD_next;
		end
	end
	reg [7:0] iSCR_next;
	task UartScrMethod_func;
		begin
			iSCR_next = iSCR;
			if (iSCRWrite == 1)
				iSCR_next = iDIN;
		end
	endtask
	always @(Wb8Uart16750.iDIN or Wb8Uart16750.iSCRWrite or Wb8Uart16750.iSCR) begin : UartScrMethod_comb
		UartScrMethod_func;
	end
	always @(posedge clk_i) begin : UartScrMethod_ff
		if (rst_i)
			iSCR <= 0;
		else
			iSCR <= iSCR_next;
	end
	reg [7:0] iTSR_next0;
	reg [1:0] tx_state_next;
	task UartTxMethod_func;
		begin
			iTSR_next0 = iTSR;
			tx_state_next = tx_state;
			tx_state_next = next_tx_state;
			iTSR_next0 = iTSR_next;
		end
	endtask
	always @(Wb8Uart16750.iTSR_next or Wb8Uart16750.next_tx_state or Wb8Uart16750.tx_state or Wb8Uart16750.iTSR) begin : UartTxMethod_comb
		UartTxMethod_func;
	end
	always @(posedge clk_i) begin : UartTxMethod_ff
		if (rst_i) begin
			iTSR <= 0;
			tx_state <= 0;
		end
		else begin
			iTSR <= iTSR_next0;
			tx_state <= tx_state_next;
		end
	end
	reg rx_state_next;
	reg [10:0] iRXFIFOD_next;
	task UartRxMethod_func;
		begin
			iRXFIFOD_next = iRXFIFOD;
			rx_state_next = rx_state;
			rx_state_next = next_rx_state;
			iRXFIFOD_next = next_iRXFIFOD;
		end
	endtask
	always @(Wb8Uart16750.next_iRXFIFOD or Wb8Uart16750.next_rx_state or Wb8Uart16750.rx_state or Wb8Uart16750.iRXFIFOD) begin : UartRxMethod_comb
		UartRxMethod_func;
	end
	always @(posedge clk_i) begin : UartRxMethod_ff
		if (rst_i) begin
			rx_state <= 0;
			iRXFIFOD <= 0;
		end
		else begin
			rx_state <= rx_state_next;
			iRXFIFOD <= iRXFIFOD_next;
		end
	end
	reg iRTS_next;
	task UartAfcMethod_func;
		begin
			iRTS_next = iRTS;
			if ((iMCR_RTS == 0) || ((iMCR_AFE == 1) && (iRXFIFOTrigger == 1)))
				iRTS_next = 0;
			else if ((iMCR_RTS == 1) && ((iMCR_AFE == 0) || ((iMCR_AFE == 1) && (iRXFIFOEmpty == 1))))
				iRTS_next = 1;
		end
	endtask
	always @(Wb8Uart16750.iRXFIFOEmpty or Wb8Uart16750.iMCR_AFE or Wb8Uart16750.iMCR_AFE or Wb8Uart16750.iMCR_RTS or Wb8Uart16750.iRXFIFOTrigger or Wb8Uart16750.iMCR_AFE or Wb8Uart16750.iMCR_RTS or Wb8Uart16750.iRTS) begin : UartAfcMethod_comb
		UartAfcMethod_func;
	end
	always @(posedge clk_i) begin : UartAfcMethod_ff
		if (rst_i)
			iRTS <= 0;
		else
			iRTS <= iRTS_next;
	end
	reg baudoutn_o_next;
	reg out1_o_next;
	reg out2_o_next;
	reg rtsn_o_next;
	reg dtrn_o_next;
	reg sout_o_next;
	task UartOutRegsMethod_func;
		begin
			baudoutn_o_next = baudoutn_o;
			dtrn_o_next = dtrn_o;
			out1_o_next = out1_o;
			out2_o_next = out2_o;
			rtsn_o_next = rtsn_o;
			sout_o_next = sout_o;
			baudoutn_o_next = 0;
			out1_o_next = 0;
			out2_o_next = 0;
			rtsn_o_next = 0;
			dtrn_o_next = 0;
			sout_o_next = 0;
			if (iBaudtick16x == 0)
				baudoutn_o_next = 1;
			if ((iMCR_LOOP == 1) || (iMCR_OUT1 == 0))
				out1_o_next = 1;
			if ((iMCR_LOOP == 1) || (iMCR_OUT2 == 0))
				out1_o_next = 1;
			if ((iMCR_LOOP == 1) || (iRTS == 0))
				rtsn_o_next = 1;
			if ((iMCR_LOOP == 1) || (iMCR_DTR == 0))
				dtrn_o_next = 1;
			if ((iMCR_LOOP == 1) || (iSOUT == 1))
				sout_o_next = 1;
		end
	endtask
	always @(Wb8Uart16750.iSOUT or Wb8Uart16750.iMCR_LOOP or Wb8Uart16750.iMCR_DTR or Wb8Uart16750.iMCR_LOOP or Wb8Uart16750.iRTS or Wb8Uart16750.iMCR_LOOP or Wb8Uart16750.iMCR_OUT2 or Wb8Uart16750.iMCR_LOOP or Wb8Uart16750.iMCR_OUT1 or Wb8Uart16750.iMCR_LOOP or Wb8Uart16750.iBaudtick16x or Wb8Uart16750.sout_o or Wb8Uart16750.rtsn_o or Wb8Uart16750.out2_o or Wb8Uart16750.out1_o or Wb8Uart16750.dtrn_o or Wb8Uart16750.baudoutn_o) begin : UartOutRegsMethod_comb
		UartOutRegsMethod_func;
	end
	always @(posedge clk_i) begin : UartOutRegsMethod_ff
		if (rst_i) begin
			baudoutn_o <= 0;
			out1_o <= 0;
			out2_o <= 0;
			rtsn_o <= 0;
			dtrn_o <= 0;
			sout_o <= 0;
		end
		else begin
			baudoutn_o <= baudoutn_o_next;
			out1_o <= out1_o_next;
			out2_o <= out2_o_next;
			rtsn_o <= rtsn_o_next;
			dtrn_o <= dtrn_o_next;
			sout_o <= sout_o_next;
		end
	end
	always @(*) begin : UartDoutMethod
		reg [31:0] wb_dout_var;
		wb_dout_var = 0;
		if (WB_ACK_R == 1)
			case (iA)
				0:
					if (iLCR_DLAB == 0)
						wb_dout_var[7:0] = iRBR;
					else
						wb_dout_var[7:0] = iDLL;
				1:
					if (iLCR_DLAB == 0)
						wb_dout_var[7:0] = iIER;
					else
						wb_dout_var[7:0] = iDLM;
				2: wb_dout_var[7:0] = iIIR;
				3: wb_dout_var[7:0] = iLCR;
				4: wb_dout_var[7:0] = iMCR;
				5: wb_dout_var[7:0] = iLSR;
				6: wb_dout_var[7:0] = iMSR;
				7: wb_dout_var[7:0] = iSCR;
				default: wb_dout_var[7:0] = iRBR;
			endcase
		wb_dout_o = wb_dout_var;
	end
	always @(*) begin : IERCombinationMethod
		reg [7:0] iIER_var;
		iIER_var = iIER;
		iIER_var[3:0] = iIER_3_0;
		iIER_var[7:4] = 0;
		iIER = iIER_var;
	end
	always @(*) begin : IIRCombinationMethod
		reg [7:0] iIIR_var;
		iIIR_var = iIIR;
		iIIR_var[3:0] = iIIR_3_0;
		iIIR_var[7:4] = iIIR_7_4;
		iIIR = iIIR_var;
	end
	always @(*) begin : UartRxStates
		reg [10:0] iRXFIFOD_var;
		iRXFIFOD_var = 0;
		if (rst_i == 1) begin
			iRXFIFOWrite = 0;
			iRXFIFOClear = 0;
			next_iRXFIFOD = 0;
			next_rx_state = 0;
		end
		else begin
			iRXFIFOWrite = 0;
			iRXFIFOClear = iFCR_RXFIFOReset;
			next_iRXFIFOD = iRXFIFOD;
			case (rx_state)
				0:
					if (iRXFinished == 1) begin
						iRXFIFOD_var[10] = iRXBI;
						iRXFIFOD_var[9] = iRXFE;
						iRXFIFOD_var[8] = iRXPE;
						iRXFIFOD_var[7:0] = iRXData;
						next_iRXFIFOD = iRXFIFOD_var;
						if (iFCR_FIFOEnable == 0)
							iRXFIFOClear = 1;
						next_rx_state = 1;
					end
					else begin
						next_iRXFIFOD = iRXFIFOD;
						next_rx_state = 0;
					end
				1: begin
					if (iFCR_FIFOEnable == 0)
						iRXFIFOWrite = 1;
					else if (iRXFIFOFull == 0)
						iRXFIFOWrite = 1;
					next_iRXFIFOD = iRXFIFOD;
					next_rx_state = 0;
				end
				default: begin
					next_iRXFIFOD = iRXFIFOD;
					next_rx_state = 0;
				end
			endcase
		end
	end
	always @(*) begin : UartTxStates
		if (rst_i == 1) begin
			iTSR_next = 0;
			iTXStart = 0;
			iTXFIFORead = 0;
			iTXRunning = 0;
			next_tx_state = 0;
		end
		else begin
			iTXStart = 0;
			iTXFIFORead = 0;
			iTXRunning = 0;
			iTSR_next = iTSR;
			case (tx_state)
				0: begin
					if (iTXEnable == 1) begin
						iTXStart = 1;
						next_tx_state = 1;
					end
					else
						next_tx_state = 0;
					iTSR_next = iTSR;
				end
				1: begin
					iTSR_next = iTXFIFOQ;
					iTXStart = 1;
					iTXFIFORead = 1;
					next_tx_state = 2;
				end
				2: begin
					if (iTXFinished == 1)
						next_tx_state = 3;
					else
						next_tx_state = 2;
					iTSR_next = iTSR;
					iTXRunning = 1;
					iTXStart = 1;
				end
				3: begin
					iTSR_next = iTSR;
					next_tx_state = 0;
				end
				default: begin
					iTSR_next = iTSR;
					next_tx_state = 0;
				end
			endcase
		end
	end
	SlibInputSync uart_is_sin(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(sin_i),
		.q_o(iSINr)
	);
	SlibInputSync uart_is_cts(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(ctsn_i),
		.q_o(iCTSNs)
	);
	SlibInputSync uart_is_dsr(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(dsrn_i),
		.q_o(iDSRNs)
	);
	SlibInputSync uart_is_dcd(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(dcd_i),
		.q_o(iDCDNs)
	);
	SlibInputSync uart_is_ri(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(rin_i),
		.q_o(iRINs)
	);
	SlibInputFilter2 uart_if_cts(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(iBaudtick2x),
		.d_i(iCTSNs),
		.q_o(iCTSn)
	);
	SlibInputFilter2 uart_if_dsr(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(iBaudtick2x),
		.d_i(iDSRNs),
		.q_o(iDSRn)
	);
	SlibInputFilter2 uart_if_dcd(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(iBaudtick2x),
		.d_i(iDCDNs),
		.q_o(iDCDn)
	);
	SlibInputFilter2 uart_if_ri(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(iBaudtick2x),
		.d_i(iRINs),
		.q_o(iRIn)
	);
	SlibEdgeDetect uart_iic_thre_ed(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iLSR_THRE),
		.re_o(iLSR_THRERE),
		.fe_o(NC_fe_o)
	);
	SlibEdgeDetect uart_pedet(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iRXFIFOPE),
		.re_o(iPERE),
		.fe_o(NC_fe_o_2)
	);
	SlibEdgeDetect uart_fedet(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iRXFIFOFE),
		.re_o(iFERE),
		.fe_o(NC_fe_o_3)
	);
	SlibEdgeDetect uart_bidet(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iRXFIFOBI),
		.re_o(iBIRE),
		.fe_o(NC_fe_o_4)
	);
	SlibEdgeDetect uart_ed_cts(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iMSR_CTS),
		.re_o(iCTSnRE),
		.fe_o(iCTSnFE)
	);
	SlibEdgeDetect uart_ed_dsr(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iMSR_DSR),
		.re_o(iDSRnRE),
		.fe_o(iDSRnFE)
	);
	SlibEdgeDetect uart_ed_ri(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iMSR_RI),
		.re_o(iRInRE),
		.fe_o(iRInFE)
	);
	SlibEdgeDetect uart_ed_dcd(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(iMSR_DCD),
		.re_o(iDCDnRE),
		.fe_o(iDCDnFE)
	);
	SlibEdgeDetect uart_rclk(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(rclk_i),
		.re_o(iRCLK),
		.fe_o(NC_fe_o_5)
	);
	SlibClockDiv1 uart_bg2(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(iBaudtick16x),
		.q_o(iBaudtick2x)
	);
	SlibClockDiv uart_bg1(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(baudce_i),
		.q_o(clock_enable)
	);
	SlibFifo uart_txff(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.clear_i(iTXFIFOClear),
		.write_i(iTXFIFOWrite),
		.read_i(iTXFIFORead),
		.d_i(iDIN),
		.q_o(iTXFIFOQ),
		.empty_o(iTXFIFOEmpty),
		.full_o(iTXFIFO64Full),
		.usage_o(iTXFIFOUsage)
	);
	SlibFifo11 uart_rxff(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.clear_i(iRXFIFOClear),
		.write_i(iRXFIFOWrite),
		.read_i(iRXFIFORead),
		.d_i(iRXFIFOD),
		.q_o(iRXFIFOQ),
		.empty_o(iRXFIFOEmpty),
		.full_o(iRXFIFO64Full),
		.usage_o(iRXFIFOUsage)
	);
	UartInterrupt uart_iic(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ire_i(iIER_3_0),
		.lsr_i(iLSR_4_0),
		.thi_i(iTHRInterrupt),
		.rda_i(iRDAInterrupt),
		.cti_i(iCharTimeout),
		.afe_i(iMCR_AFE),
		.msr_i(iMSR_3_0),
		.iir_o(iIIR_3_0),
		.int_o(int_o)
	);
	UartBaudgen uart_bg16(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(clock_enable),
		.clear_i(NC_i),
		.divider_i(iBaudgenDiv),
		.baudtick_o(iBaudtick16x)
	);
	UartTransmitter uart_tx(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.tx_clk_i(iBaudtick2x),
		.tx_start_i(iTXStart),
		.clear_i(iTXClear),
		.wls_i(iLCR_WLS),
		.stb_i(iLCR_STB),
		.pen_i(iLCR_PEN),
		.eps_i(iLCR_EPS),
		.sp_i(iLCR_SP),
		.bc_i(iLCR_BC),
		.din_i(iTSR),
		.tx_finished_o(iTXFinished),
		.sout_o(iSOUT)
	);
	UartReceiver uart_rx(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.rx_clk_i(iRCLK),
		.rx_clear_i(iRXClear),
		.wls_i(iLCR_WLS),
		.stb_i(iLCR_STB),
		.pen_i(iLCR_PEN),
		.eps_i(iLCR_EPS),
		.sp_i(iLCR_SP),
		.sin_i(iSIN),
		.pe_o(iRXPE),
		.fe_o(iRXFE),
		.bi_o(iRXBI),
		.dout_o(iRXData),
		.rx_finished_o(iRXFinished)
	);
endmodule
module SlibInputSync (
	clk_i,
	rst_i,
	d_i,
	q_o
);
	input wire clk_i;
	input wire rst_i;
	input wire d_i;
	output reg q_o;
	reg [0:1] d;
	always @(*) begin : OutputMethod
		q_o = d[1];
	end
	reg [0:1] d_next;
	task InputSyncMethod_func;
		begin
			d_next = d;
			d_next[0] = d_i;
			d_next[1] = d[0];
		end
	endtask
	always @(SlibInputSync.d[0] or SlibInputSync.d_i or SlibInputSync.d) begin : InputSyncMethod_comb
		InputSyncMethod_func;
	end
	always @(posedge clk_i) begin : InputSyncMethod_ff
		if (rst_i) begin : sv2v_autoblock_1
			reg [7:0] i;
			for (i = 0; $signed({1'b0, i}) < 2; i = i + 1)
				d[i] <= 0;
		end
		else
			d <= d_next;
	end
endmodule
module SlibInputFilter2 (
	clk_i,
	rst_i,
	ce_i,
	d_i,
	q_o
);
	input wire clk_i;
	input wire rst_i;
	input wire ce_i;
	input wire d_i;
	output reg q_o;
	reg [2:0] count;
	reg [2:0] count_next;
	reg q_o_next;
	task InputFilterMethod_func;
		begin
			count_next = count;
			q_o_next = q_o;
			if (ce_i == 1)
				if ((d_i == 1) && (count != 2))
					count_next = count + 1;
				else if ((d_i == 0) && (count != 0))
					count_next = count - 1;
			if (count == 2)
				q_o_next = 1;
			else if (count == 0)
				q_o_next = 0;
			else if (count > 2)
				count_next = 2;
		end
	endtask
	always @(SlibInputFilter2.count or SlibInputFilter2.count or SlibInputFilter2.count or SlibInputFilter2.count or SlibInputFilter2.count or SlibInputFilter2.d_i or SlibInputFilter2.count or SlibInputFilter2.count or SlibInputFilter2.d_i or SlibInputFilter2.ce_i or SlibInputFilter2.q_o or SlibInputFilter2.count) begin : InputFilterMethod_comb
		InputFilterMethod_func;
	end
	always @(posedge clk_i) begin : InputFilterMethod_ff
		if (rst_i)
			count <= 0;
		else begin
			count <= count_next;
			q_o <= q_o_next;
		end
	end
endmodule
module SlibEdgeDetect (
	clk_i,
	rst_i,
	d_i,
	re_o,
	fe_o
);
	input wire clk_i;
	input wire rst_i;
	input wire d_i;
	output reg re_o;
	output reg fe_o;
	reg idd;
	always @(*) begin : OutputMethod
		re_o = ((idd == 0) && (d_i == 1) ? 1 : 0);
		fe_o = ((idd == 1) && (d_i == 0) ? 1 : 0);
	end
	reg idd_next;
	task EdgeDetectMethod_func;
		begin
			idd_next = idd;
			idd_next = d_i;
		end
	endtask
	always @(SlibEdgeDetect.d_i or SlibEdgeDetect.idd) begin : EdgeDetectMethod_comb
		EdgeDetectMethod_func;
	end
	always @(posedge clk_i) begin : EdgeDetectMethod_ff
		if (rst_i)
			idd <= 0;
		else
			idd <= idd_next;
	end
endmodule
module SlibClockDiv1 (
	clk_i,
	rst_i,
	ce_i,
	q_o
);
	input wire clk_i;
	input wire rst_i;
	input wire ce_i;
	output reg q_o;
	reg iq;
	reg [3:0] counter;
	always @(*) begin : OutputMethod
		q_o = iq;
	end
	reg iq_next;
	reg [3:0] counter_next;
	task ClockDivMethod_func;
		begin
			counter_next = counter;
			iq_next = iq;
			iq_next = 0;
			if (ce_i == 1)
				if (counter == 7) begin
					iq_next = 1;
					counter_next = 0;
				end
				else
					counter_next = counter + 1;
		end
	endtask
	always @(SlibClockDiv1.counter or SlibClockDiv1.counter or SlibClockDiv1.ce_i or SlibClockDiv1.iq or SlibClockDiv1.counter) begin : ClockDivMethod_comb
		ClockDivMethod_func;
	end
	always @(posedge clk_i) begin : ClockDivMethod_ff
		if (rst_i) begin
			iq <= 0;
			counter <= 0;
		end
		else begin
			iq <= iq_next;
			counter <= counter_next;
		end
	end
endmodule
module SlibClockDiv (
	clk_i,
	rst_i,
	ce_i,
	q_o
);
	input wire clk_i;
	input wire rst_i;
	input wire ce_i;
	output reg q_o;
	reg iq;
	reg [4:0] counter;
	always @(*) begin : OutputMethod
		q_o = iq;
	end
	reg iq_next;
	reg [4:0] counter_next;
	task ClockDivMethod_func;
		begin
			counter_next = counter;
			iq_next = iq;
			iq_next = 0;
			if (ce_i == 1)
				if (counter == 13) begin
					iq_next = 1;
					counter_next = 0;
				end
				else
					counter_next = counter + 1;
		end
	endtask
	always @(SlibClockDiv.counter or SlibClockDiv.counter or SlibClockDiv.ce_i or SlibClockDiv.iq or SlibClockDiv.counter) begin : ClockDivMethod_comb
		ClockDivMethod_func;
	end
	always @(posedge clk_i) begin : ClockDivMethod_ff
		if (rst_i) begin
			iq <= 0;
			counter <= 0;
		end
		else begin
			iq <= iq_next;
			counter <= counter_next;
		end
	end
endmodule
module SlibFifo (
	clk_i,
	rst_i,
	clear_i,
	write_i,
	read_i,
	d_i,
	q_o,
	empty_o,
	full_o,
	usage_o
);
	input wire clk_i;
	input wire rst_i;
	input wire clear_i;
	input wire write_i;
	input wire read_i;
	input wire [7:0] d_i;
	output reg [7:0] q_o;
	output reg empty_o;
	output reg full_o;
	output reg [5:0] usage_o;
	reg empty;
	reg full;
	reg [6:0] WRAddr;
	reg [6:0] RDAddr;
	reg [5:0] Usage;
	reg [511:0] FifoMem;
	always @(*) begin : OutputMethod
		reg [6:0] RDAddr_internal;
		reg [6:0] WRAddr_internal;
		RDAddr_internal = RDAddr;
		WRAddr_internal = WRAddr;
		if ((RDAddr_internal[5:0] == WRAddr_internal[5:0]) && (RDAddr_internal[6] != WRAddr_internal[6]))
			full = 1;
		else
			full = 0;
		empty_o = empty;
		full_o = full;
		usage_o = Usage;
	end
	reg [6:0] WRAddr_next;
	reg [6:0] RDAddr_next;
	reg empty_next;
	task AdrMethod_func;
		begin
			RDAddr_next = RDAddr;
			WRAddr_next = WRAddr;
			empty_next = empty;
			if ((write_i == 1) && (full == 0))
				WRAddr_next = WRAddr + 1;
			if ((read_i == 1) && (empty == 0))
				RDAddr_next = RDAddr + 1;
			if (clear_i == 1) begin
				WRAddr_next = 0;
				RDAddr_next = 0;
			end
			if (RDAddr == WRAddr)
				empty_next = 1;
			else
				empty_next = 0;
		end
	endtask
	always @(SlibFifo.WRAddr or SlibFifo.RDAddr or SlibFifo.clear_i or SlibFifo.RDAddr or SlibFifo.empty or SlibFifo.read_i or SlibFifo.WRAddr or SlibFifo.full or SlibFifo.write_i or SlibFifo.empty or SlibFifo.WRAddr or SlibFifo.RDAddr) begin : AdrMethod_comb
		AdrMethod_func;
	end
	always @(posedge clk_i) begin : AdrMethod_ff
		if (rst_i) begin
			WRAddr <= 0;
			RDAddr <= 0;
			empty <= 1;
		end
		else begin
			WRAddr <= WRAddr_next;
			RDAddr <= RDAddr_next;
			empty <= empty_next;
		end
	end
	reg [511:0] FifoMem_next;
	reg [7:0] q_o_next;
	task MemMethod_func;
		reg [6:0] RDAddr_internal;
		reg [6:0] WRAddr_internal;
		begin
			FifoMem_next = FifoMem;
			q_o_next = q_o;
			RDAddr_internal = RDAddr;
			WRAddr_internal = WRAddr;
			if ((write_i == 1) && (full == 0))
				FifoMem_next[(63 - WRAddr_internal[5:0]) * 8+:8] = d_i;
			q_o_next = FifoMem[(63 - RDAddr_internal[5:0]) * 8+:8];
		end
	endtask
	always @(SlibFifo.FifoMem or SlibFifo.d_i or SlibFifo.full or SlibFifo.write_i or SlibFifo.WRAddr or SlibFifo.RDAddr or SlibFifo.q_o or SlibFifo.FifoMem) begin : MemMethod_comb
		MemMethod_func;
	end
	always @(posedge clk_i) begin : MemMethod_ff
		if (rst_i) begin : sv2v_autoblock_1
			reg [6:0] RDAddr_internal;
			reg [6:0] WRAddr_internal;
			RDAddr_internal = 0;
			WRAddr_internal = 0;
		end
		else begin
			FifoMem <= FifoMem_next;
			q_o <= q_o_next;
		end
	end
	reg [5:0] Usage_next;
	task UsageMethod_func;
		begin
			Usage_next = Usage;
			if (clear_i == 1)
				Usage_next = 0;
			else begin
				if (((read_i == 0) && (write_i == 1)) && (full == 0))
					Usage_next = Usage + 1;
				if (((read_i == 1) && (write_i == 0)) && (empty == 0))
					Usage_next = Usage - 1;
			end
		end
	endtask
	always @(SlibFifo.Usage or SlibFifo.empty or SlibFifo.write_i or SlibFifo.read_i or SlibFifo.Usage or SlibFifo.full or SlibFifo.write_i or SlibFifo.read_i or SlibFifo.clear_i or SlibFifo.Usage) begin : UsageMethod_comb
		UsageMethod_func;
	end
	always @(posedge clk_i) begin : UsageMethod_ff
		if (rst_i)
			Usage <= 0;
		else
			Usage <= Usage_next;
	end
endmodule
module SlibFifo11 (
	clk_i,
	rst_i,
	clear_i,
	write_i,
	read_i,
	d_i,
	q_o,
	empty_o,
	full_o,
	usage_o
);
	input wire clk_i;
	input wire rst_i;
	input wire clear_i;
	input wire write_i;
	input wire read_i;
	input wire [10:0] d_i;
	output reg [10:0] q_o;
	output reg empty_o;
	output reg full_o;
	output reg [5:0] usage_o;
	reg empty;
	reg full;
	reg [6:0] WRAddr;
	reg [6:0] RDAddr;
	reg [5:0] Usage;
	reg [703:0] FifoMem;
	always @(*) begin : OutputMethod
		reg [6:0] RDAddr_internal;
		reg [6:0] WRAddr_internal;
		RDAddr_internal = RDAddr;
		WRAddr_internal = WRAddr;
		if ((RDAddr_internal[5:0] == WRAddr_internal[5:0]) && (RDAddr_internal[6] != WRAddr_internal[6]))
			full = 1;
		else
			full = 0;
		empty_o = empty;
		full_o = full;
		usage_o = Usage;
	end
	reg [6:0] WRAddr_next;
	reg [6:0] RDAddr_next;
	reg empty_next;
	task AdrMethod_func;
		begin
			RDAddr_next = RDAddr;
			WRAddr_next = WRAddr;
			empty_next = empty;
			if ((write_i == 1) && (full == 0))
				WRAddr_next = WRAddr + 1;
			if ((read_i == 1) && (empty == 0))
				RDAddr_next = RDAddr + 1;
			if (clear_i == 1) begin
				WRAddr_next = 0;
				RDAddr_next = 0;
			end
			if (RDAddr == WRAddr)
				empty_next = 1;
			else
				empty_next = 0;
		end
	endtask
	always @(SlibFifo11.WRAddr or SlibFifo11.RDAddr or SlibFifo11.clear_i or SlibFifo11.RDAddr or SlibFifo11.empty or SlibFifo11.read_i or SlibFifo11.WRAddr or SlibFifo11.full or SlibFifo11.write_i or SlibFifo11.empty or SlibFifo11.WRAddr or SlibFifo11.RDAddr) begin : AdrMethod_comb
		AdrMethod_func;
	end
	always @(posedge clk_i) begin : AdrMethod_ff
		if (rst_i) begin
			WRAddr <= 0;
			RDAddr <= 0;
			empty <= 1;
		end
		else begin
			WRAddr <= WRAddr_next;
			RDAddr <= RDAddr_next;
			empty <= empty_next;
		end
	end
	reg [703:0] FifoMem_next;
	reg [10:0] q_o_next;
	task MemMethod_func;
		reg [6:0] RDAddr_internal;
		reg [6:0] WRAddr_internal;
		begin
			FifoMem_next = FifoMem;
			q_o_next = q_o;
			RDAddr_internal = RDAddr;
			WRAddr_internal = WRAddr;
			if ((write_i == 1) && (full == 0))
				FifoMem_next[(63 - WRAddr_internal[5:0]) * 11+:11] = d_i;
			q_o_next = FifoMem[(63 - RDAddr_internal[5:0]) * 11+:11];
		end
	endtask
	always @(SlibFifo11.FifoMem or SlibFifo11.d_i or SlibFifo11.full or SlibFifo11.write_i or SlibFifo11.WRAddr or SlibFifo11.RDAddr or SlibFifo11.q_o or SlibFifo11.FifoMem) begin : MemMethod_comb
		MemMethod_func;
	end
	always @(posedge clk_i) begin : MemMethod_ff
		if (rst_i) begin : sv2v_autoblock_1
			reg [6:0] RDAddr_internal;
			reg [6:0] WRAddr_internal;
			RDAddr_internal = 0;
			WRAddr_internal = 0;
		end
		else begin
			FifoMem <= FifoMem_next;
			q_o <= q_o_next;
		end
	end
	reg [5:0] Usage_next;
	task UsageMethod_func;
		begin
			Usage_next = Usage;
			if (clear_i == 1)
				Usage_next = 0;
			else begin
				if (((read_i == 0) && (write_i == 1)) && (full == 0))
					Usage_next = Usage + 1;
				if (((read_i == 1) && (write_i == 0)) && (empty == 0))
					Usage_next = Usage - 1;
			end
		end
	endtask
	always @(SlibFifo11.Usage or SlibFifo11.empty or SlibFifo11.write_i or SlibFifo11.read_i or SlibFifo11.Usage or SlibFifo11.full or SlibFifo11.write_i or SlibFifo11.read_i or SlibFifo11.clear_i or SlibFifo11.Usage) begin : UsageMethod_comb
		UsageMethod_func;
	end
	always @(posedge clk_i) begin : UsageMethod_ff
		if (rst_i)
			Usage <= 0;
		else
			Usage <= Usage_next;
	end
endmodule
module UartInterrupt (
	clk_i,
	rst_i,
	ire_i,
	lsr_i,
	thi_i,
	rda_i,
	cti_i,
	afe_i,
	msr_i,
	iir_o,
	int_o
);
	input wire clk_i;
	input wire rst_i;
	input wire [3:0] ire_i;
	input wire [4:0] lsr_i;
	input wire thi_i;
	input wire rda_i;
	input wire cti_i;
	input wire afe_i;
	input wire [3:0] msr_i;
	output reg [3:0] iir_o;
	output reg int_o;
	reg RLSInterrupt;
	reg RDAInterrupt;
	reg CTIInterrupt;
	reg THRInterrupt;
	reg MSRInterrupt;
	reg [3:0] IIR;
	always @(*) begin : OutputMethod
		reg [3:0] ire_internal;
		reg [4:0] lsr_internal;
		reg [3:0] msr_internal;
		reg [3:0] iir_internal;
		ire_internal = ire_i;
		lsr_internal = lsr_i;
		msr_internal = msr_i;
		iir_internal = IIR;
		if ((ire_internal[2] == 1) && ((((lsr_internal[1] == 1) || (lsr_internal[2] == 1)) || (lsr_internal[3] == 1)) || (lsr_internal[4] == 1)))
			RLSInterrupt = 1;
		else
			RLSInterrupt = 0;
		if ((ire_internal[2] == 1) && (rda_i == 1))
			RDAInterrupt = 1;
		else
			RDAInterrupt = 0;
		if ((ire_internal[0] == 1) && (cti_i == 1))
			CTIInterrupt = 1;
		else
			CTIInterrupt = 0;
		if ((ire_internal[1] == 1) && (thi_i == 1))
			THRInterrupt = 1;
		else
			THRInterrupt = 0;
		if ((ire_internal[3] == 1) && (((((msr_internal[0] == 1) && (afe_i == 0)) || (msr_internal[1] == 1)) || (msr_internal[2] == 1)) || (msr_internal[3] == 1)))
			MSRInterrupt = 1;
		else
			MSRInterrupt = 0;
		iir_o = iir_internal;
		int_o = !iir_internal[0];
	end
	reg [3:0] IIR_next;
	task InterruptMethod_func;
		begin
			IIR_next = IIR;
			if (RLSInterrupt == 1)
				IIR_next = 'h6;
			else if (CTIInterrupt == 1)
				IIR_next = 'hc;
			else if (RDAInterrupt == 1)
				IIR_next = 'h4;
			else if (THRInterrupt == 1)
				IIR_next = 'h2;
			else if (MSRInterrupt == 1)
				IIR_next = 0;
			else
				IIR_next = 1;
		end
	endtask
	always @(UartInterrupt.MSRInterrupt or UartInterrupt.THRInterrupt or UartInterrupt.RDAInterrupt or UartInterrupt.CTIInterrupt or UartInterrupt.RLSInterrupt or UartInterrupt.IIR) begin : InterruptMethod_comb
		InterruptMethod_func;
	end
	always @(posedge clk_i) begin : InterruptMethod_ff
		if (rst_i)
			IIR <= 1;
		else
			IIR <= IIR_next;
	end
endmodule
module UartBaudgen (
	clk_i,
	rst_i,
	ce_i,
	clear_i,
	divider_i,
	baudtick_o
);
	input wire clk_i;
	input wire rst_i;
	input wire ce_i;
	input wire clear_i;
	input wire [15:0] divider_i;
	output reg baudtick_o;
	reg [15:0] counter;
	reg [15:0] counter_next;
	reg baudtick_o_next;
	task BaudgenMethod_func;
		begin
			baudtick_o_next = baudtick_o;
			counter_next = counter;
			if (clear_i == 1)
				counter_next = 0;
			else if (ce_i == 1)
				counter_next = counter + 1;
			baudtick_o_next = 0;
			if (counter == divider_i) begin
				counter_next = 0;
				baudtick_o_next = 1;
			end
		end
	endtask
	always @(UartBaudgen.divider_i or UartBaudgen.counter or UartBaudgen.counter or UartBaudgen.ce_i or UartBaudgen.clear_i or UartBaudgen.counter or UartBaudgen.baudtick_o) begin : BaudgenMethod_comb
		BaudgenMethod_func;
	end
	always @(posedge clk_i) begin : BaudgenMethod_ff
		if (rst_i) begin
			counter <= 0;
			baudtick_o <= 0;
		end
		else begin
			counter <= counter_next;
			baudtick_o <= baudtick_o_next;
		end
	end
endmodule
module UartTransmitter (
	clk_i,
	rst_i,
	tx_clk_i,
	tx_start_i,
	clear_i,
	wls_i,
	stb_i,
	pen_i,
	eps_i,
	sp_i,
	bc_i,
	din_i,
	tx_finished_o,
	sout_o
);
	input wire clk_i;
	input wire rst_i;
	input wire tx_clk_i;
	input wire tx_start_i;
	input wire clear_i;
	input wire [1:0] wls_i;
	input wire stb_i;
	input wire pen_i;
	input wire eps_i;
	input wire sp_i;
	input wire bc_i;
	input wire [7:0] din_i;
	output reg tx_finished_o;
	output reg sout_o;
	reg iTx2;
	reg iSout;
	reg iParity;
	reg iFinished;
	reg [4:0] tx_state;
	reg [4:0] next_tx_state;
	always @(*) begin : OutputMethod
		if (bc_i == 0)
			sout_o = iSout;
		else
			sout_o = 0;
		tx_finished_o = iFinished;
	end
	always @(*) begin : TX_FMSMethod
		reg [7:0] din_internal;
		din_internal = din_i;
		next_tx_state = 0;
		iSout = 1;
		case (tx_state)
			0:
				if (tx_start_i == 1)
					next_tx_state = 1;
			1: begin
				iSout = 0;
				next_tx_state = 2;
			end
			2: begin
				iSout = din_internal[0];
				next_tx_state = 3;
			end
			3: begin
				iSout = din_internal[1];
				next_tx_state = 4;
			end
			4: begin
				iSout = din_internal[2];
				next_tx_state = 5;
			end
			5: begin
				iSout = din_internal[3];
				next_tx_state = 6;
			end
			6: begin
				iSout = din_internal[4];
				if (wls_i == 0) begin
					if (pen_i == 1)
						next_tx_state = 10;
					else
						next_tx_state = 11;
				end
				else
					next_tx_state = 7;
			end
			7: begin
				iSout = din_internal[5];
				if (wls_i == 1) begin
					if (pen_i == 1)
						next_tx_state = 10;
					else
						next_tx_state = 11;
				end
				else
					next_tx_state = 8;
			end
			8: begin
				iSout = din_internal[6];
				if (wls_i == 2) begin
					if (pen_i == 1)
						next_tx_state = 10;
					else
						next_tx_state = 11;
				end
				else
					next_tx_state = 9;
			end
			9: begin
				iSout = din_internal[7];
				if (pen_i == 1)
					next_tx_state = 10;
				else
					next_tx_state = 11;
			end
			10: begin
				if (sp_i == 1) begin
					if (eps_i == 1)
						iSout = 0;
					else
						iSout = 1;
				end
				else if (eps_i == 1)
					iSout = iParity;
				else
					iSout = !iParity;
				next_tx_state = 11;
			end
			11:
				if (stb_i == 1)
					next_tx_state = 12;
				else if (tx_start_i == 1)
					next_tx_state = 1;
			12:
				if (tx_start_i == 1)
					next_tx_state = 1;
			default:
				;
		endcase
	end
	always @(*) begin : TX_PARMethod
		reg iP40;
		reg iP50;
		reg iP60;
		reg iP70;
		reg [7:0] din_internal;
		iP40 = 0;
		iP50 = 0;
		iP60 = 0;
		iP70 = 0;
		din_internal = din_i;
		iP40 = (((din_internal[4] ^ din_internal[3]) ^ din_internal[2]) ^ din_internal[1]) ^ din_internal[0];
		iP50 = din_internal[5] ^ iP40;
		iP60 = din_internal[6] ^ iP50;
		iP70 = din_internal[7] ^ iP60;
		case (wls_i)
			0: iParity = iP40;
			1: iParity = iP50;
			2: iParity = iP60;
			default: iParity = iP70;
		endcase
	end
	reg iFinished_next;
	reg iLast;
	reg iLast_next;
	task TX_FINMethod_func;
		begin
			iFinished_next = iFinished;
			iLast_next = iLast;
			iFinished_next = 0;
			if ((iLast_next == 0) && (tx_state == 11))
				iFinished_next = 1;
			if (tx_state == 11)
				iLast_next = 1;
			else
				iLast_next = 0;
		end
	endtask
	always @(UartTransmitter.tx_state or UartTransmitter.tx_state or UartTransmitter.iLast_next or UartTransmitter.iLast or UartTransmitter.iFinished) begin : TX_FINMethod_comb
		TX_FINMethod_func;
	end
	always @(posedge clk_i) begin : TX_FINMethod_ff
		if (rst_i) begin
			iFinished <= 0;
			iLast <= 0;
		end
		else begin
			iFinished <= iFinished_next;
			iLast <= iLast_next;
		end
	end
	reg [4:0] tx_state_next;
	reg iTx2_next;
	task TXMethod_func;
		begin
			iTx2_next = iTx2;
			tx_state_next = tx_state;
			if (tx_clk_i == 1)
				if (iTx2 == 0) begin
					tx_state_next = next_tx_state;
					iTx2_next = 1;
				end
				else if (((wls_i == 0) && (stb_i == 1)) && (tx_state == 12)) begin
					tx_state_next = next_tx_state;
					iTx2_next = 1;
				end
				else begin
					tx_state_next = tx_state;
					iTx2_next = 0;
				end
		end
	endtask
	always @(UartTransmitter.tx_state or UartTransmitter.next_tx_state or UartTransmitter.tx_state or UartTransmitter.stb_i or UartTransmitter.wls_i or UartTransmitter.next_tx_state or UartTransmitter.iTx2 or UartTransmitter.tx_clk_i or UartTransmitter.tx_state or UartTransmitter.iTx2) begin : TXMethod_comb
		TXMethod_func;
	end
	always @(posedge clk_i) begin : TXMethod_ff
		if (rst_i) begin
			tx_state <= 0;
			iTx2 <= 0;
		end
		else begin
			tx_state <= tx_state_next;
			iTx2 <= iTx2_next;
		end
	end
endmodule
module UartReceiver (
	clk_i,
	rst_i,
	rx_clk_i,
	rx_clear_i,
	wls_i,
	stb_i,
	pen_i,
	eps_i,
	sp_i,
	sin_i,
	pe_o,
	fe_o,
	bi_o,
	dout_o,
	rx_finished_o
);
	input wire clk_i;
	input wire rst_i;
	input wire rx_clk_i;
	input wire rx_clear_i;
	input wire [1:0] wls_i;
	input wire stb_i;
	input wire pen_i;
	input wire eps_i;
	input wire sp_i;
	input wire sin_i;
	output reg pe_o;
	output reg fe_o;
	output reg bi_o;
	output reg [7:0] dout_o;
	output reg rx_finished_o;
	wire [3:0] iBaudCount;
	reg iBaudCountClear;
	wire iBaudStep;
	reg iBaudStepD;
	reg iFilterClear;
	wire iFSIN;
	wire iFStopBit;
	reg iParity;
	reg iParityReceived;
	reg [4:0] iDataCount;
	reg iDataCountInit;
	reg iDataCountFinish;
	reg iRXFinished;
	reg iFE;
	reg iBI;
	reg iNoStopReceived;
	reg [7:0] iDOUT;
	reg [3:0] iRxState;
	reg [3:0] iRxNextState;
	wire iNoConnect;
	wire [3:0] iNoConnect4;
	always @(*) begin : OutputMethod
		if (((((wls_i == 0) && (iDataCount == 5)) || ((wls_i == 1) && (iDataCount == 6))) || ((wls_i == 2) && (iDataCount == 7))) || ((wls_i == 3) && (iDataCount == 8)))
			iDataCountFinish = 1;
		else
			iDataCountFinish = 0;
		if ((iFStopBit == 0) && (iRxState == 4))
			iNoStopReceived = 1;
		else
			iNoStopReceived = 0;
		if (((iDOUT == 0) && (iParityReceived == 0)) && (iNoStopReceived == 1))
			iBI = 1;
		else
			iBI = 0;
		if (iNoStopReceived == 1)
			iFE = 1;
		else
			iFE = 0;
		iFilterClear = (iBaudStepD == 1) || (iBaudCountClear == 1);
		dout_o = iDOUT;
		bi_o = iBI;
		fe_o = iFE;
		rx_finished_o = iRXFinished;
	end
	always @(*) begin : ParityGenerationMethod
		reg [7:0] iDoutInternal;
		iDoutInternal = iDOUT;
		iParity = (((((((iDoutInternal[7] ^ iDoutInternal[6]) ^ iDoutInternal[5]) ^ iDoutInternal[4]) ^ iDoutInternal[3]) ^ iDoutInternal[2]) ^ iDoutInternal[1]) ^ iDoutInternal[0]) ^ !eps_i;
	end
	always @(*) begin : StateMachineMethod
		reg [3:0] iBaudCountInternal;
		iRxNextState = 0;
		iBaudCountClear = 0;
		iDataCountInit = 0;
		iRXFinished = 0;
		iBaudCountInternal = iBaudCount;
		case (iRxState)
			0: begin
				if (sin_i == 0)
					iRxNextState = 1;
				iBaudCountClear = 1;
				iDataCountInit = 1;
			end
			1: begin
				iDataCountInit = 1;
				if (iBaudStep == 1) begin
					if (iFSIN == 0)
						iRxNextState = 2;
				end
				else
					iRxNextState = 1;
			end
			2:
				if (iDataCountFinish == 1) begin
					if (pen_i == 1)
						iRxNextState = 3;
					else
						iRxNextState = 4;
				end
				else
					iRxNextState = 2;
			3:
				if (iBaudStep == 1)
					iRxNextState = 4;
				else
					iRxNextState = 3;
			4:
				if (iBaudCountInternal[3] == 1) begin
					if (iFStopBit == 0) begin
						iRXFinished = 1;
						iRxNextState = 5;
					end
					else begin
						iRXFinished = 1;
						iRxNextState = 0;
					end
				end
				else
					iRxNextState = 4;
			5:
				if (sin_i == 0)
					iRxNextState = 5;
			default:
				;
		endcase
	end
	reg iBaudStepD_next;
	task BaudstepDMethod_func;
		begin
			iBaudStepD_next = iBaudStepD;
			iBaudStepD_next = iBaudStep;
		end
	endtask
	always @(UartReceiver.iBaudStep or UartReceiver.iBaudStepD) begin : BaudstepDMethod_comb
		BaudstepDMethod_func;
	end
	always @(posedge clk_i) begin : BaudstepDMethod_ff
		if (rst_i)
			iBaudStepD <= 0;
		else
			iBaudStepD <= iBaudStepD_next;
	end
	reg [4:0] iDataCount_next;
	reg [7:0] iDOUT_next;
	task DataBitCaptureMethod_func;
		reg [7:0] iDOUT_internal;
		begin
			iDOUT_internal = 0;
			iDOUT_next = iDOUT;
			iDataCount_next = iDataCount;
			if (iDataCountInit == 1) begin
				iDataCount_next = 0;
				iDOUT_next = 0;
			end
			else if ((iBaudStep == 1) && (iDataCountFinish == 0)) begin
				iDOUT_internal = iDOUT;
				iDOUT_internal[iDataCount] = iFSIN;
				iDataCount_next = iDataCount + 1;
				iDOUT_next = iDOUT_internal;
			end
		end
	endtask
	always @(UartReceiver.iDataCount or UartReceiver.iFSIN or UartReceiver.iDataCount or UartReceiver.iDOUT or UartReceiver.iDataCountFinish or UartReceiver.iBaudStep or UartReceiver.iDataCountInit or UartReceiver.iDataCount or UartReceiver.iDOUT) begin : DataBitCaptureMethod_comb
		DataBitCaptureMethod_func;
	end
	always @(posedge clk_i) begin : DataBitCaptureMethod_ff
		if (rst_i) begin
			iDataCount <= 0;
			iDOUT <= 0;
		end
		else begin
			iDataCount <= iDataCount_next;
			iDOUT <= iDOUT_next;
		end
	end
	reg [3:0] iRxState_next;
	task FSMUpdateMethod_func;
		begin
			iRxState_next = iRxState;
			iRxState_next = iRxNextState;
		end
	endtask
	always @(UartReceiver.iRxNextState or UartReceiver.iRxState) begin : FSMUpdateMethod_comb
		FSMUpdateMethod_func;
	end
	always @(posedge clk_i) begin : FSMUpdateMethod_ff
		if (rst_i)
			iRxState <= 0;
		else
			iRxState <= iRxState_next;
	end
	reg pe_o_next;
	reg iParityReceived_next;
	task CheckParityMethod_func;
		begin
			iParityReceived_next = iParityReceived;
			pe_o_next = pe_o;
			if ((iRxState == 3) && (iBaudStep == 1))
				iParityReceived_next = iFSIN;
			if (pen_i == 1) begin
				pe_o_next = 0;
				if (sp_i == 1) begin
					if ((eps_i ^ iParityReceived) == 0)
						pe_o_next = 1;
				end
				else if (iParity != iParityReceived)
					pe_o_next = 1;
			end
			else begin
				pe_o_next = 0;
				iParityReceived_next = 0;
			end
		end
	endtask
	always @(UartReceiver.iParityReceived or UartReceiver.iParity or UartReceiver.iParityReceived or UartReceiver.eps_i or UartReceiver.sp_i or UartReceiver.pen_i or UartReceiver.iFSIN or UartReceiver.iBaudStep or UartReceiver.iRxState or UartReceiver.pe_o or UartReceiver.iParityReceived) begin : CheckParityMethod_comb
		CheckParityMethod_func;
	end
	always @(posedge clk_i) begin : CheckParityMethod_ff
		if (rst_i) begin
			pe_o <= 0;
			iParityReceived <= 0;
		end
		else begin
			pe_o <= pe_o_next;
			iParityReceived <= iParityReceived_next;
		end
	end
	SlibCounter rx_brc(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.clear_i(iBaudCountClear),
		.load_i(iNoConnect),
		.enable_i(rx_clk_i),
		.down_i(iNoConnect),
		.d_i(iNoConnect4),
		.q_o(iBaudCount),
		.overflow_o(iBaudStep)
	);
	SlibMVFilter rxmvf(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.d_i(sin_i),
		.sample_i(rx_clk_i),
		.clear_i(iFilterClear),
		.q_o(iFSIN)
	);
	SlibInputFilter rx_isfsb(
		.clk_i(clk_i),
		.rst_i(rst_i),
		.ce_i(rx_clk_i),
		.d_i(sin_i),
		.q_o(iFStopBit)
	);
endmodule
module SlibCounter (
	clk_i,
	rst_i,
	clear_i,
	load_i,
	enable_i,
	down_i,
	d_i,
	q_o,
	overflow_o
);
	input wire clk_i;
	input wire rst_i;
	input wire clear_i;
	input wire load_i;
	input wire enable_i;
	input wire down_i;
	input wire [3:0] d_i;
	output reg [3:0] q_o;
	output reg overflow_o;
	reg [4:0] counter;
	always @(*) begin : OutputMethod
		reg [4:0] counter_internal;
		counter_internal = counter;
		overflow_o = counter_internal[4];
		q_o = counter_internal[3:0];
	end
	reg [4:0] counter_next;
	task CounterMethod_func;
		reg [4:0] counter_internal;
		begin
			counter_next = counter;
			if (clear_i == 1)
				counter_next = 0;
			else if (load_i == 1)
				counter_next = {1'd0, d_i};
			else if (enable_i == 1)
				if (down_i == 0)
					counter_next = counter + 1;
				else
					counter_next = counter - 1;
			counter_internal = counter;
			if (counter_internal[4] == 1) begin
				counter_internal[4] = 0;
				counter_next = counter_internal;
			end
		end
	endtask
	always @(SlibCounter.counter or SlibCounter.counter or SlibCounter.counter or SlibCounter.down_i or SlibCounter.enable_i or SlibCounter.d_i or SlibCounter.load_i or SlibCounter.clear_i or SlibCounter.counter) begin : CounterMethod_comb
		CounterMethod_func;
	end
	always @(posedge clk_i) begin : CounterMethod_ff
		if (rst_i)
			counter <= 0;
		else
			counter <= counter_next;
	end
endmodule
module SlibMVFilter (
	clk_i,
	rst_i,
	d_i,
	sample_i,
	clear_i,
	q_o
);
	input wire clk_i;
	input wire rst_i;
	input wire d_i;
	input wire sample_i;
	input wire clear_i;
	output reg q_o;
	reg q;
	reg [4:0] counter;
	always @(*) begin : OutputMethod
		q_o = q;
	end
	reg [4:0] counter_next;
	reg q_next;
	task MVMethod_func;
		begin
			counter_next = counter;
			q_next = q;
			if (counter >= 10)
				q_next = 1;
			else if ((sample_i == 1) && (d_i == 1))
				counter_next = counter + 1;
			if (clear_i == 1) begin
				counter_next = 0;
				q_next = 0;
			end
		end
	endtask
	always @(SlibMVFilter.clear_i or SlibMVFilter.counter or SlibMVFilter.d_i or SlibMVFilter.sample_i or SlibMVFilter.counter or SlibMVFilter.q or SlibMVFilter.counter) begin : MVMethod_comb
		MVMethod_func;
	end
	always @(posedge clk_i) begin : MVMethod_ff
		if (rst_i) begin
			counter <= 0;
			q <= 0;
		end
		else begin
			counter <= counter_next;
			q <= q_next;
		end
	end
endmodule
module SlibInputFilter (
	clk_i,
	rst_i,
	ce_i,
	d_i,
	q_o
);
	input wire clk_i;
	input wire rst_i;
	input wire ce_i;
	input wire d_i;
	output reg q_o;
	reg [2:0] count;
	reg [2:0] count_next;
	reg q_o_next;
	task InputFilterMethod_func;
		begin
			count_next = count;
			q_o_next = q_o;
			if (ce_i == 1)
				if ((d_i == 1) && (count != 4))
					count_next = count + 1;
				else if ((d_i == 0) && (count != 0))
					count_next = count - 1;
			if (count == 4)
				q_o_next = 1;
			else if (count == 0)
				q_o_next = 0;
			else if (count > 4)
				count_next = 4;
		end
	endtask
	always @(SlibInputFilter.count or SlibInputFilter.count or SlibInputFilter.count or SlibInputFilter.count or SlibInputFilter.count or SlibInputFilter.d_i or SlibInputFilter.count or SlibInputFilter.count or SlibInputFilter.d_i or SlibInputFilter.ce_i or SlibInputFilter.q_o or SlibInputFilter.count) begin : InputFilterMethod_comb
		InputFilterMethod_func;
	end
	always @(posedge clk_i) begin : InputFilterMethod_ff
		if (rst_i)
			count <= 0;
		else begin
			count <= count_next;
			q_o <= q_o_next;
		end
	end
endmodule
