## Author: Abdurrahman Celep
## Please 


## Summary
This application demonstrates a simple rust application without Cargo Environment.

It create a simple print output.

## Requirements

* Linux x86_64 compatible computer (tested with Debian 11.3)

* Basic development utilities installed (GNU Make, etc.)

* Installed RISC-V toolchain (tested with [SiFive Toolchain 2020.04](https://github.com/sifive/freedom-tools/releases/tag/v2020.04.0-Toolchain.Only)
with riscv64-unknown-elf-gcc and other tools visible to the command line.
(for example by using following command): 

```sh
$ export PATH=$PATH:$<RISCV_TOOLCHAIN_DIR>/bin/
```
* Also set RISCV_HOME enviroment variable

```sh
$ export RISCV_HOME=$<RISCV_TOOLCHAIN_DIR>
```

* Installed clang compiler (tested with version 11.0.1-2)

* As well as this repository checked out and libparanut built (```make -C ../libparanut build```).
The path of this repository will be referenced as $paranut_root from now on.

* BASH compatible shell

* curl to intall rustc, cargo and rustup

* rustc Compiler to work with rust Code (tested with version 1.65.0)

* cargo to install the creates (tested with version 1.65.0)

* rustup the installer for Rust (1.25.1)

* To install rustc, cargo and rustup 

```sh
$ curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh
```
* To work with nightly Channel (tested with version 1.68)
```sh
$ rustup install nightly
```

* To work with RV32I Base Integer Instruction Set add the target riscv32i-unknown-none-elf for stable

```sh
$ rustup target add riscv32i-unknown-none-elf
```

* and for nightly

```sh
$ rustup +nightly target add riscv32i-unknown-none-elf
```

## Building
In case this application is to be executed on hardware, 
it is recommended to build this application using the same config.mk as the hardware configuration.

To build this application make sure "settings.sh" is still sourced,
as well as the toolchain.

Enter this directory and run make:

```sh
$ cd ./sw/hello_rust/ # Relative to $paranut_root
$ make
```

## Running
To test the application simply run following command from within the directory with this README (same as the one used before):

```sh
$ make sim
```

In case hardware has been built as mentioned in the main [README file of the ParaNut project](../../README.md#operating-a-paranut-on-real-hardware).
Following command can be used for running the built application on hardware.

```sh
$ pn-flash -p hello_rust.bin -b ../../systems/refdesign/hardware/build/system.bit ../../systems/refdesign/hardware/build/system.hdf ../../systems/refdesign/hardware/firmware/firmware.elf
```
