#![allow(non_camel_case_types)]
#![allow(unused_variables)]
#![no_std]
#![no_main]

use bindgen_stdio_sys as stdio;
use bindgen_paranut_sys as paranut;

#[no_mangle]
pub extern "C" fn main(_nargs: i32, _args: *const *const u8) -> i32 {
    unsafe {
        stdio::puts(b"\nHello, ParaNut!\n\0" as *const u8 as *const i8);
        stdio::puts(b"The code was programmed with rust.\n\0" as *const u8 as *const i8);
        stdio::puts(b"It also uses C libraries like libparanut and stdio.\n\0" as *const u8 as *const i8);
        stdio::printf(
            b"At the moment %d CPUs are active.\n\n\0" as *const u8 as *const i8,
            paranut::pn_numcores(),
        );
        stdio::puts(
            b"Special about the project is, that it works with ...\n\0" as *const u8
                as *const i8,
        );
        for index in 0..9 {
            stdio::puts(b"the Cargo Environment\n\0" as *const u8 as *const i8);
        }
    }

    // Exit with a return status of 0.
    0
}

use core::{panic::PanicInfo};

#[panic_handler]
fn panic(_panic: &PanicInfo<'_>) -> ! {
    loop {}
}
